<a id="mypy-boto3-opsworkscm"></a>

# mypy-boto3-opsworkscm

[![PyPI - mypy-boto3-opsworkscm](https://img.shields.io/pypi/v/mypy-boto3-opsworkscm.svg?color=blue)](https://pypi.org/project/mypy-boto3-opsworkscm)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-opsworkscm.svg?color=blue)](https://pypi.org/project/mypy-boto3-opsworkscm)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-opsworkscm?color=blue)](https://pypistats.org/packages/mypy-boto3-opsworkscm)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.OpsWorksCM 1.19.2](https://boto3.amazonaws.com/v1/documentation/api/1.19.2/reference/services/opsworkscm.html#OpsWorksCM)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.0.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-opsworkscm docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_opsworkscm/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-opsworkscm](#mypy-boto3-opsworkscm)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

Install `boto3-stubs` for `OpsWorksCM` service.

```bash
python -m pip install boto3-stubs[opsworkscm]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[opsworkscm]` in your environment:
  `python -m pip install 'boto3-stubs[opsworkscm]'`

Both type checking and auto-complete should work for `OpsWorksCM` service. No
explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `boto-stubs[opsworkscm]` in your environment:
  `python -m pip install 'boto3-stubs[opsworkscm]'`

Both type checking and auto-complete should work for `OpsWorksCM` service. No
explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`boto3-stubs` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[opsworkscm]` in your environment:
  `python -m pip install 'boto3-stubs[opsworkscm]'`
- Run `mypy` as usual

Type checking should work for `OpsWorksCM` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[opsworkscm]` in your environment:
  `python -m pip install 'boto3-stubs[opsworkscm]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `OpsWorksCM` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`OpsWorksCMClient` provides annotations for `boto3.client("opsworkscm")`.

```python
import boto3

from mypy_boto3_opsworkscm import OpsWorksCMClient

client: OpsWorksCMClient = boto3.client("opsworkscm")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: OpsWorksCMClient = session.client("opsworkscm")
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_opsworkscm.paginator` module contains type annotations for all
paginators.

```python
from mypy_boto3_opsworkscm import OpsWorksCMClient
from mypy_boto3_opsworkscm.paginator import (
    DescribeBackupsPaginator,
    DescribeEventsPaginator,
    DescribeServersPaginator,
    ListTagsForResourcePaginator,
)

client: OpsWorksCMClient = boto3.client("opsworkscm")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
describe_backups_paginator: DescribeBackupsPaginator = client.get_paginator("describe_backups")
describe_events_paginator: DescribeEventsPaginator = client.get_paginator("describe_events")
describe_servers_paginator: DescribeServersPaginator = client.get_paginator("describe_servers")
list_tags_for_resource_paginator: ListTagsForResourcePaginator = client.get_paginator("list_tags_for_resource")
```

<a id="waiters-annotations"></a>

### Waiters annotations

`mypy_boto3_opsworkscm.waiter` module contains type annotations for all
waiters.

```python
from mypy_boto3_opsworkscm import OpsWorksCMClient
from mypy_boto3_opsworkscm.waiter import (
    NodeAssociatedWaiter,
)

client: OpsWorksCMClient = boto3.client("opsworkscm")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
node_associated_waiter: NodeAssociatedWaiter = client.get_waiter("node_associated")
```

<a id="literals"></a>

### Literals

`mypy_boto3_opsworkscm.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from mypy_boto3_opsworkscm.literals import (
    BackupStatusType,
    BackupTypeType,
    DescribeBackupsPaginatorName,
    DescribeEventsPaginatorName,
    DescribeServersPaginatorName,
    ListTagsForResourcePaginatorName,
    MaintenanceStatusType,
    NodeAssociatedWaiterName,
    NodeAssociationStatusType,
    ServerStatusType,
    ServiceName,
    PaginatorName,
    WaiterName,
)

def check_value(value: BackupStatusType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_opsworkscm.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_opsworkscm.type_defs import (
    AccountAttributeTypeDef,
    AssociateNodeRequestRequestTypeDef,
    AssociateNodeResponseTypeDef,
    BackupTypeDef,
    CreateBackupRequestRequestTypeDef,
    CreateBackupResponseTypeDef,
    CreateServerRequestRequestTypeDef,
    CreateServerResponseTypeDef,
    DeleteBackupRequestRequestTypeDef,
    DeleteServerRequestRequestTypeDef,
    DescribeAccountAttributesResponseTypeDef,
    DescribeBackupsRequestRequestTypeDef,
    DescribeBackupsResponseTypeDef,
    DescribeEventsRequestRequestTypeDef,
    DescribeEventsResponseTypeDef,
    DescribeNodeAssociationStatusRequestRequestTypeDef,
    DescribeNodeAssociationStatusResponseTypeDef,
    DescribeServersRequestRequestTypeDef,
    DescribeServersResponseTypeDef,
    DisassociateNodeRequestRequestTypeDef,
    DisassociateNodeResponseTypeDef,
    EngineAttributeTypeDef,
    ExportServerEngineAttributeRequestRequestTypeDef,
    ExportServerEngineAttributeResponseTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    PaginatorConfigTypeDef,
    ResponseMetadataTypeDef,
    RestoreServerRequestRequestTypeDef,
    RestoreServerResponseTypeDef,
    ServerEventTypeDef,
    ServerTypeDef,
    StartMaintenanceRequestRequestTypeDef,
    StartMaintenanceResponseTypeDef,
    TagResourceRequestRequestTypeDef,
    TagTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateServerEngineAttributesRequestRequestTypeDef,
    UpdateServerEngineAttributesResponseTypeDef,
    UpdateServerRequestRequestTypeDef,
    UpdateServerResponseTypeDef,
    WaiterConfigTypeDef,
)

def get_structure() -> AccountAttributeTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`mypy-boto3-opsworkscm` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[mypy-boto3-opsworkscm docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_opsworkscm/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
